import { l as l$1, y as y$1, createStylesheet, __setFunctionName, __esDecorate, __runInitializers, PreactCustomElement, __classPrivateFieldGet, __classPrivateFieldSet } from './index2.js';
import { define, reactive } from './define.js';
import { boolean } from './boolean.js';
import { string } from './string.js';
import { tagName } from '../components/TimePicker/meta.js';
import { classMap } from './classMap.js';

var t,r,u,i,o=0,f=[],c=[],e=l$1.__b,a=l$1.__r,v=l$1.diffed,l=l$1.__c,m=l$1.unmount;function d(t,u){l$1.__h&&l$1.__h(r,t,o||u),o=0;var i=r.__H||(r.__H={__:[],__h:[]});return t>=i.__.length&&i.__.push({__V:c}),i.__[t]}function h(n){return o=1,s(B,n)}function s(n,u,i){var o=d(t++,2);if(o.t=n,!o.__c&&(o.__=[i?i(u):B(void 0,u),function(n){var t=o.__N?o.__N[0]:o.__[0],r=o.t(t,n);t!==r&&(o.__N=[r,o.__[1]],o.__c.setState({}));}],o.__c=r,!r.u)){var f=function(n,t,r){if(!o.__c.__H)return !0;var u=o.__c.__H.__.filter(function(n){return n.__c});if(u.every(function(n){return !n.__N}))return !c||c.call(this,n,t,r);var i=!1;return u.forEach(function(n){if(n.__N){var t=n.__[0];n.__=n.__N,n.__N=void 0,t!==n.__[0]&&(i=!0);}}),!(!i&&o.__c.props===n)&&(!c||c.call(this,n,t,r))};r.u=!0;var c=r.shouldComponentUpdate,e=r.componentWillUpdate;r.componentWillUpdate=function(n,t,r){if(this.__e){var u=c;c=void 0,f(n,t,r),c=u;}e&&e.call(this,n,t,r);},r.shouldComponentUpdate=f;}return o.__N||o.__}function p(u,i){var o=d(t++,3);!l$1.__s&&z(o.__H,i)&&(o.__=u,o.i=i,r.__H.__h.push(o));}function y(u,i){var o=d(t++,4);!l$1.__s&&z(o.__H,i)&&(o.__=u,o.i=i,r.__h.push(o));}function _(n){return o=5,F(function(){return {current:n}},[])}function F(n,r){var u=d(t++,7);return z(u.__H,r)?(u.__V=n(),u.i=r,u.__h=n,u.__V):u.__}function T(n,t){return o=8,F(function(){return n},t)}function b(){for(var t;t=f.shift();)if(t.__P&&t.__H)try{t.__H.__h.forEach(k),t.__H.__h.forEach(w),t.__H.__h=[];}catch(r){t.__H.__h=[],l$1.__e(r,t.__v);}}l$1.__b=function(n){r=null,e&&e(n);},l$1.__r=function(n){a&&a(n),t=0;var i=(r=n.__c).__H;i&&(u===r?(i.__h=[],r.__h=[],i.__.forEach(function(n){n.__N&&(n.__=n.__N),n.__V=c,n.__N=n.i=void 0;})):(i.__h.forEach(k),i.__h.forEach(w),i.__h=[],t=0)),u=r;},l$1.diffed=function(t){v&&v(t);var o=t.__c;o&&o.__H&&(o.__H.__h.length&&(1!==f.push(o)&&i===l$1.requestAnimationFrame||((i=l$1.requestAnimationFrame)||j)(b)),o.__H.__.forEach(function(n){n.i&&(n.__H=n.i),n.__V!==c&&(n.__=n.__V),n.i=void 0,n.__V=c;})),u=r=null;},l$1.__c=function(t,r){r.some(function(t){try{t.__h.forEach(k),t.__h=t.__h.filter(function(n){return !n.__||w(n)});}catch(u){r.some(function(n){n.__h&&(n.__h=[]);}),r=[],l$1.__e(u,t.__v);}}),l&&l(t,r);},l$1.unmount=function(t){m&&m(t);var r,u=t.__c;u&&u.__H&&(u.__H.__.forEach(function(n){try{k(n);}catch(n){r=n;}}),u.__H=void 0,r&&l$1.__e(r,u.__v));};var g="function"==typeof requestAnimationFrame;function j(n){var t,r=function(){clearTimeout(u),g&&cancelAnimationFrame(t),setTimeout(n);},u=setTimeout(r,100);g&&(t=requestAnimationFrame(r));}function k(n){var t=r,u=n.__c;"function"==typeof u&&(n.__c=void 0,u()),r=t;}function w(n){var t=r;n.__c=n.__(),r=t;}function z(n,t){return !n||n.length!==t.length||t.some(function(t,r){return t!==n[r]})}function B(n,t){return "function"==typeof t?t(n):t}

/**
 * Create a lazy-loaded component.
 *
 * @param factory A function that returns a promise for an object with a `default` property that's the target component.
 * @returns A component with the same props as the target component, but with an additional `fallback` prop.
 *
 * @example
 * ```tsx
 * const LazyComponent = lazyComponent(() => import('./MyComponent'));
 *
 * function App() {
 *  return <LazyComponent fallback={<div>Loading...</div>} other="props" go="here" />;
 * }
 * ```
 */
function lazyComponent(factory) {
    let componentPromise;
    let componentStateSetter;
    const LazyComponent = (props) => {
        const { fallback, ...rest } = props;
        const [Component, setComponent] = h(componentStateSetter);
        if (!componentStateSetter) {
            if (!componentPromise) {
                componentPromise = factory().then((m) => m.default);
            }
            // Chill, errors are handled in the function.
            // eslint-disable-next-line @typescript-eslint/no-floating-promises
            (async () => {
                const Component = await componentPromise.catch((error) => {
                    // As a fallback, return a callback that throws the error
                    return () => {
                        throw error;
                    };
                });
                // setComponent & useState have an overload that accepts a function.
                // Since the value we're setting is also a function (components are functions),
                // we need to wrap it in a function.
                componentStateSetter = () => Component;
                setComponent(componentStateSetter);
            })();
        }
        if (Component)
            return y$1(Component, { ...rest });
        return fallback !== null && fallback !== void 0 ? fallback : null;
    };
    return LazyComponent;
}

const shadow$1 = createStylesheet(":host{font-family:\"Inter\",-apple-system,BlinkMacSystemFont,\"San Francisco\",\"Segoe UI\",Roboto,\"Helvetica Neue\",sans-serif}.time-picker{border-radius:.75rem;box-shadow:0 .25rem .375rem -.125rem rgba(26,26,26,.2);border:.0625rem solid #e3e3e3;overflow:hidden;font-size:.8125rem}header{display:flex;align-items:center;gap:5px;padding:.25rem .5rem}header h4{padding:.5rem 0;margin:0;position:sticky;top:0;background-color:#fff;font-weight:650}.time-picker.disabled header{color:#b5b5b5}");

const LazyTimePickerMain = lazyComponent(() => import('./TimePickerMain.js'));
function ShadowRoot(element) {
    const { disabled } = element;
    return (y$1("div", { class: classMap({
            'time-picker': true,
            disabled,
        }) },
        y$1(LazyTimePickerMain, { fallback: y$1("header", null,
                y$1("h4", null, "Select\u2026")), element: element })));
}

const shadow = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.defineProperty({
    __proto__: null,
    ShadowRoot,
    styles: shadow$1
}, Symbol.toStringTag, { value: 'Module' }));

let TimePicker = (() => {
    var _TimePicker_allowRanges_accessor_storage, _TimePicker_disallowRanges_accessor_storage, _TimePicker_steps_accessor_storage, _TimePicker_disabled_accessor_storage, _TimePicker_defaultValue_accessor_storage, _TimePicker_value_accessor_storage;
    let _classDecorators = [define(tagName)];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = PreactCustomElement;
    let _instanceExtraInitializers = [];
    let _allowRanges_decorators;
    let _allowRanges_initializers = [];
    let _disallowRanges_decorators;
    let _disallowRanges_initializers = [];
    let _steps_decorators;
    let _steps_initializers = [];
    let _disabled_decorators;
    let _disabled_initializers = [];
    let _defaultValue_decorators;
    let _defaultValue_initializers = [];
    let _value_decorators;
    let _value_initializers = [];
    _classThis = class extends _classSuper {
        get allowRanges() { return __classPrivateFieldGet(this, _TimePicker_allowRanges_accessor_storage, "f"); }
        set allowRanges(value) { __classPrivateFieldSet(this, _TimePicker_allowRanges_accessor_storage, value, "f"); }
        get disallowRanges() { return __classPrivateFieldGet(this, _TimePicker_disallowRanges_accessor_storage, "f"); }
        set disallowRanges(value) { __classPrivateFieldSet(this, _TimePicker_disallowRanges_accessor_storage, value, "f"); }
        get steps() { return __classPrivateFieldGet(this, _TimePicker_steps_accessor_storage, "f"); }
        set steps(value) { __classPrivateFieldSet(this, _TimePicker_steps_accessor_storage, value, "f"); }
        get disabled() { return __classPrivateFieldGet(this, _TimePicker_disabled_accessor_storage, "f"); }
        set disabled(value) { __classPrivateFieldSet(this, _TimePicker_disabled_accessor_storage, value, "f"); }
        get defaultValue() { return __classPrivateFieldGet(this, _TimePicker_defaultValue_accessor_storage, "f"); }
        set defaultValue(value) { __classPrivateFieldSet(this, _TimePicker_defaultValue_accessor_storage, value, "f"); }
        get value() { return __classPrivateFieldGet(this, _TimePicker_value_accessor_storage, "f"); }
        set value(value) { __classPrivateFieldSet(this, _TimePicker_value_accessor_storage, value, "f"); }
        constructor() {
            super(shadow);
            _TimePicker_allowRanges_accessor_storage.set(this, (__runInitializers(this, _instanceExtraInitializers), __runInitializers(this, _allowRanges_initializers, void 0)));
            _TimePicker_disallowRanges_accessor_storage.set(this, __runInitializers(this, _disallowRanges_initializers, void 0));
            _TimePicker_steps_accessor_storage.set(this, __runInitializers(this, _steps_initializers, void 0));
            _TimePicker_disabled_accessor_storage.set(this, __runInitializers(this, _disabled_initializers, void 0));
            _TimePicker_defaultValue_accessor_storage.set(this, __runInitializers(this, _defaultValue_initializers, void 0));
            _TimePicker_value_accessor_storage.set(this, __runInitializers(this, _value_initializers, void 0));
        }
    };
    _TimePicker_allowRanges_accessor_storage = new WeakMap();
    _TimePicker_disallowRanges_accessor_storage = new WeakMap();
    _TimePicker_steps_accessor_storage = new WeakMap();
    _TimePicker_disabled_accessor_storage = new WeakMap();
    _TimePicker_defaultValue_accessor_storage = new WeakMap();
    _TimePicker_value_accessor_storage = new WeakMap();
    __setFunctionName(_classThis, "TimePicker");
    (() => {
        var _a;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_a = _classSuper[Symbol.metadata]) !== null && _a !== void 0 ? _a : null) : void 0;
        _allowRanges_decorators = [reactive(string())];
        _disallowRanges_decorators = [reactive(string())];
        _steps_decorators = [reactive(string())];
        _disabled_decorators = [reactive(boolean())];
        _defaultValue_decorators = [reactive(string())];
        _value_decorators = [reactive(string())];
        __esDecorate(_classThis, null, _allowRanges_decorators, { kind: "accessor", name: "allowRanges", static: false, private: false, access: { has: obj => "allowRanges" in obj, get: obj => obj.allowRanges, set: (obj, value) => { obj.allowRanges = value; } }, metadata: _metadata }, _allowRanges_initializers, _instanceExtraInitializers);
        __esDecorate(_classThis, null, _disallowRanges_decorators, { kind: "accessor", name: "disallowRanges", static: false, private: false, access: { has: obj => "disallowRanges" in obj, get: obj => obj.disallowRanges, set: (obj, value) => { obj.disallowRanges = value; } }, metadata: _metadata }, _disallowRanges_initializers, _instanceExtraInitializers);
        __esDecorate(_classThis, null, _steps_decorators, { kind: "accessor", name: "steps", static: false, private: false, access: { has: obj => "steps" in obj, get: obj => obj.steps, set: (obj, value) => { obj.steps = value; } }, metadata: _metadata }, _steps_initializers, _instanceExtraInitializers);
        __esDecorate(_classThis, null, _disabled_decorators, { kind: "accessor", name: "disabled", static: false, private: false, access: { has: obj => "disabled" in obj, get: obj => obj.disabled, set: (obj, value) => { obj.disabled = value; } }, metadata: _metadata }, _disabled_initializers, _instanceExtraInitializers);
        __esDecorate(_classThis, null, _defaultValue_decorators, { kind: "accessor", name: "defaultValue", static: false, private: false, access: { has: obj => "defaultValue" in obj, get: obj => obj.defaultValue, set: (obj, value) => { obj.defaultValue = value; } }, metadata: _metadata }, _defaultValue_initializers, _instanceExtraInitializers);
        __esDecorate(_classThis, null, _value_decorators, { kind: "accessor", name: "value", static: false, private: false, access: { has: obj => "value" in obj, get: obj => obj.value, set: (obj, value) => { obj.value = value; } }, metadata: _metadata }, _value_initializers, _instanceExtraInitializers);
        __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
        _classThis = _classDescriptor.value;
        if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        __runInitializers(_classThis, _classExtraInitializers);
    })();
    return _classThis;
})();

export { F, T, TimePicker, _, h, p, y };
